﻿<template>
    <v-app>
        <v-form ref="form"
                v-model="valid"
                lazy-validation>
            <v-row>
                <v-col cols="12">
                    <v-select v-model="selectedClientId"
                              :items="clientArr"
                              item-text="companyName"
                              item-value="id"
                              :menu-props="{ maxHeight: '400' }"
                              label="Выберите клиента"
                              persistent-hint></v-select>
                </v-col>
                <v-col cols="12">
                    <v-text-field v-model="title"
                                  :rules="titleRules"
                                  label="Название проекта"
                                  required></v-text-field>
                </v-col>
                <v-spacer></v-spacer>
                <v-col class="d-flex" cols="12" sm="3" xsm="12" align-end>
                    <v-btn :disabled="!valid"
                           color="success"
                           class="mr-4"
                           @click="onProjectCreate">
                        Отправить
                    </v-btn>
                </v-col>
            </v-row>
        </v-form>
    </v-app>
</template>

<script>
    import { mapActions, mapGetters } from 'vuex'

    export default {
        data() {
            return {
                valid: true,
                clientArr: [],
                selectedClientId: '',
                title: '',
                titleRules: [
                    v => !!v || 'Поле title не должен быть пустым',
                ],
            }
        },
        created() {
            this.onClientAllData();
        },
        computed: {
            ...mapGetters('client', ['getClientAllData']),
        },
        methods: {
            ...mapActions('client', ['onClientAllData']),
            validate() {
                this.$refs.form.validate()
            },
            async onProjectCreate() {
                await this.validate()
                if (this.valid) {
                    let title = this.title;
                    let clientId = this.selectedClientId;
                    this.$store
                        .dispatch('project/projectCreate',
                            {
                                clientId,
                                title
                            }
                        )
                        .then(() => {
                            this.$router.push({ name: 'Home' })
                        })
                        .catch(err => {
                            if (err) {
                                this.title = '';
                                this.titleRules = [
                                    v => !!v || 'Поле title не должен быть пустым'
                                ];
                            }
                        })
                } else return
            }
        },
        watch: {
            getClientAllData() {
                if (this.getClientAllData != undefined) {
                    this.clientArr = this.getClientAllData;
                }
            }
        }
    }
</script>

